<template>
  <div>
    <div class="charts-page-top">
      <button
        v-if="!showSavingCampStats"
        class="btn btn-success show-charts-stats-btn"
        @click="showSavingCampaignsStats()"
      >Show saving campaigns stats</button>
      <button
        v-if="showSavingCampStats"
        class="btn btn-success show-charts-stats-btn"
        @click="showMainStats()"
      >Show main stats</button>

      <date-picker
        v-if="showSavingCampStats"
        placeholder="Select month interval"
        v-model="month_interval"
        range
        type="month"
        :lang="lang"
      ></date-picker>
      <date-picker
        v-else
        placeholder="Select date interval"
        v-model="date_interval"
        range
        type="date"
        :lang="lang"
      ></date-picker>
    </div>
    <div v-if="showSavingCampStats" class="charts-container">
      <div v-if="!savCampDataNotFound" class="row">
        <div class="col-md-4 col-sm-12">
          <SavingCampaignsCategoriesStats
            v-if="savingCampaignsStats"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="savingCampaignsStats.categoriesStats"
            v-bind:date_interval="month_interval"
          ></SavingCampaignsCategoriesStats>
        </div>
        <div class="col-md-4 col-sm-12">
          <SavingCampaignsTotalStats
            v-if="savingCampaignsStats && !areChartsEmpty"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="savingCampaignsStats.totalStats"
            v-bind:date_interval="month_interval"
          ></SavingCampaignsTotalStats>
        </div>
        <div class="col-md-4 col-sm-12">
          <SavingCampaignsCategoryStats
            v-if="savingCampaignsStats && !areChartsEmpty"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="savingCampaignsStats.categoryStats"
            v-bind:date_interval="month_interval"
            v-bind:categories="categories"
          ></SavingCampaignsCategoryStats>
        </div>
      </div>
    </div>

    <div v-if="!showSavingCampStats" class="charts-container">
      <div v-if="!mainDataNotFound" class="row">
        <div class="col-md-4 col-sm-12">
          <CategoriesStats
            v-if="chartsStats"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="chartsStats.categoriesStats"
            v-bind:date_interval="date_interval"
          ></CategoriesStats>
          <CategoryBeneficiariesStats
            v-if="chartsStats"
            v-bind:date_interval="date_interval"
            v-bind:categories="filteredCategories"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="chartsStats.categoryBeneficiariesStats"
          ></CategoryBeneficiariesStats>
        </div>

        <div class="col-md-4 col-sm-12">
          <TotalStats
            v-if="chartsStats"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="chartsStats.totalStats"
            v-bind:date_interval="date_interval"
          ></TotalStats>
          <CategoryStats
            v-if="chartsStats && filteredCategories"
            v-bind:categories="filteredCategories"
            v-bind:interval="formatted_date_interval"
            v-bind:stats="chartsStats.categoryStats"
            v-bind:date_interval="date_interval"
          ></CategoryStats>
        </div>
        <div class="col-md-4 col-sm-12">
          <BeneficiaryStats
            v-if="chartsStats && beneficiaries"
            v-bind:beneficiaries="beneficiaries"
            v-bind:stats="chartsStats.beneficiaryStats"
            v-bind:interval="formatted_date_interval"
            v-bind:date_interval="date_interval"
          ></BeneficiaryStats>
          <CategoryBeneficiaryStats
            v-if="chartsStats && categoryBeneficiaries && filteredCategories"
            v-bind:beneficiaries.sync="categoryBeneficiaries"
            v-bind:categories="filteredCategories"
            v-bind:stats="chartsStats.categoryBeneficiaryStats"
            v-bind:interval="formatted_date_interval"
            v-bind:date_interval="date_interval"
          ></CategoryBeneficiaryStats>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
import CategoryStats from "./charts/CategoryStats.vue";
import CategoriesStats from "./charts/CategoriesStats.vue";
import TotalStats from "./charts/TotalStats.vue";
import CategoryBeneficiariesStats from "./charts/CategoryBeneficiariesStats.vue";
import CategoryBeneficiaryStats from "./charts/CategoryBeneficiaryStats.vue";
import BeneficiaryStats from "./charts/BeneficiaryStats";
import SavingCampaignsCategoriesStats from "./charts/SavingCampaignsCategoriesStats";
import SavingCampaignsTotalStats from "./charts/SavingCampaignsTotalStats";
import SavingCampaignsCategoryStats from "./charts/SavingCampaignsCategoryStats";
import moment from "moment";
export default {
  components: {
    CategoriesStats,
    TotalStats,
    CategoryStats,
    CategoryBeneficiariesStats,
    CategoryBeneficiaryStats,
    BeneficiaryStats,
    SavingCampaignsCategoriesStats,
    SavingCampaignsTotalStats,
    SavingCampaignsCategoryStats
  },

  data: function() {
    return {
      showSavingCampStats: null,
      formatted_date_interval: "null/null",
      formatted_month_interval: "null/null",
      beneficiaries: null,
      categoryBeneficiaries: null,
      filteredCategories: null,
      categories: null,
      chartsStats: null,
      date_interval: [null, null],
      month_interval: [null, null],
      savingCampaignsStats: null,
      mainDataNotFound: true,
      savCampDataNotFound: true,
      areChartsEmpty: false,
      savingCampaignsStatsStatus: [
        {
          checkedForCategories: false,
          categoriesFound: false
        }
      ],
      lang: "en",
      shortcuts: [
        {
        //   text: "Today",
        //   onClick: () => {
        //     this.date_interval = [
        //       new Date("2017-05-08"),
        //       new Date("2017-08-08")
        //     ];
        //   }
         }
      ],
      timePickerOptions: {
        start: "00:00",
        step: "00:30",
        end: "23:30"
      },
      date_title: "All time results"
    };
  },

  watch: {
    date_interval: function() {
      this.formatted_date_interval = this.parseInterval(this.date_interval);
      this.getMainChartsStats();
    },

    month_interval: function() {
      this.formatted_month_interval = this.parseInterval(this.month_interval);

      this.getSavingCampaignsChartsStats();
    }
  },

  methods: {
    showSavingCampaignsStats() {
      this.showSavingCampStats = true;
      this.getSavingCampaignsChartsStats();
    },
    showMainStats() {
      this.showSavingCampStats = false;
      this.getMainChartsStats();
    },
    parseInterval(date) {
      if (date[0] && date[1]) {
        return moment(date[0]).format('YYYY-MM-DD') + "/" + moment(date[1]).format('YYYY-MM-DD');
      } else {
        return "null/null";
      }
    },
    getMainChartsStats() {
      this.$Progress.start();
      let uri = "api/main-charts-stats/" + this.formatted_date_interval;
      axios
        .get(uri)
        .then(response => {
          this.mainDataNotFound = response.data.dataNotFound;
          if (this.mainDataNotFound) {
            this.$Progress.fail();
            swal("Failed!", "No transactions found", "warning");
          } else {
            this.chartsStats = response.data;
            (this.categoryBeneficiaries = response.data.categoryBeneficiaries),
              (this.beneficiaries = response.data.beneficiaries),
              (this.filteredCategories = response.data.transactionsCategories);
            this.$Progress.finish();
          }
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    getSavingCampaignsChartsStats() {
      this.$Progress.start();
      let uri =
        "api/saving-campaigns-charts-stats/" + this.formatted_month_interval;
      axios
        .get(uri)
        .then(response => {
          if (!this.checkedForCategories) {
            this.savCampDataNotFound = response.data.dataNotFound;
            this.checkedForCategories = false;
          }

          if (this.savCampDataNotFound) {
            this.$Progress.fail();
            swal("Failed!", "No categories found", "warning");
          } else {
            this.savingCampaignsStats = response.data;
            this.categories = response.data.categories;
            this.areChartsEmpty = response.data.areChartsEmpty;
            this.$Progress.finish();
          }
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    getDateTitle() {
      let parsed_date_from = moment(this.date_interval[0])
        .format("MM/DD/YYYY")
        .toString();

      let parsed_date_to = moment(this.date_interval[1])
        .format("MM/DD/YYYY")
        .toString();

      this.date_title =
        "Results from " + parsed_date_from + " to " + parsed_date_to;
    }
  },
  created() {
    this.getMainChartsStats();
  }
};
</script>